MaDGiC Pentomino
----------------

Auteur         : Moaku / ICQ: 76799582
Page du projet : http://psp.madgic.ch

Le projet consiste a partir sur une base de jeu simple et legere afin de
par la suite rajouter diverses variantes / fonctions / effets petit a
petit afin de me faire les dents sur le pspsdk et ses librairies.

J'ai choisi comme theme le Pentomino. En recherchant sur google, je suis
tombe sur de nombreuses variantes que je ne connaissait pas n'utilisant
pas de chiffres, je me suis dit que du coup cette base de jeu que j'ai
appris lorsque j'avais 10 ans serait parfaite.

Installation:
-------------

PSP 1.0: Copiez le dossier MaDGiCPentomino-1.0 dans /psp/game/ de votre memory
         stick.

PSP 1.5: Copiez les dossiers MaDGiC~1% et MaDGiCPentomino________________1 dans
         /psp/game/ de votre memory stick.

Regles:
-------

Chaque mode de jeu pourra avoir ses variantes de regles, referez-vous aux
ecrans d'aide dans le jeu pour connaitre ces variantes.
Toutefois, les regles de base sont a connaitre avant de jouer.

Le but est simple, on nous donne des formes, ou plus precisement des
pentominos (formes composees de 5 carres adjacents), et il faut placer ces
formes librement (direction, face) sur une grille de nombres afin que la
somme des chiffres contenus sur les cases recouvertes soit le plus elevee
possible.

Touches:
--------

Menu:
  Haut/Bas (Digital ou analogique)      : Deplacement dans le menu
  Gauche/Droite (Digital ou analogique) : Changement de la valeur selectionnee
  X                                     : Executer la fonction du menu en cours

Jeu:
  Directions (Digital ou analogique) : Deplacement
  X                                  : Placer Piece
  []                                 : Piece suivante
  Triangle                           : Piece precedente
  Start                              : Menu
  Select                             : Capture les mouvements de la partie
                                       dans le fichier "snapshot.gsd"
                                       (Ecran de titre = gfx/titlescreen.gsd :))
  L                                  : Rotation sens inv. aiguille d'une montre
  R                                  : Rotation sens aiguilles d'une montre
                                       (8 sens et non 4! (5 a 8 = retournee))

Version en cours: 0.1.0
-----------------------

A faire avant 1.0.0:
- Ameliorer le look des menus
- Fixer le plantage lorsqu'on quitte le jeu
- Ajouter un mode 2 joueurs
- Ajouter des sons
- Ameliorer le look de l'interface de jeu
- Ajouter une fonction pour synchroniser les hi-scores entre plusieurs joueurs via
  WiFi
- Ajouter une fonction "Replay" resequencant la partie en cours
- Ajouter un mode de jeu "Remplir" ou le but est de remplir completement une grille
  chiffree avec des formes libres
  (Nombre de cases en trop bouchees aleatoirement sur la grille).
  Le temps et le % d'approche du score potentiel total seront des modificateurs de 
  score
- Ajouter la possibilite de faire une grille plus grande que l'ecran avec un scroll
- Ajouter un rendu en "Fausse 3d isometrique" 
  (Ca ressemble a de la 3d iso (donc de la 2d), mais en fait c'est de la 3d pure)
- Generer le README automatiquement depuis une base de donnees

A faire avant 0.2.0:
- Optimiser l'effet de fondu
- Ajouter la possibilite d'annuler des placements
- Ajouter des ecrans d'aide
- Calculer la taille de grille max en fonction de la taille du bloc en vue de
  permettre de pouvoir faire des skins avec des blocs de n'importe quelle taille
- Prevoir la possibilite pour les skins d'avoir une tile de fond de n'importe
  quelle taille
  
Changements:
------------

V 0.1.0 (Premiere version publique):
  - Le systeme d'enregistrement et de listage de profils a ete ameliore
    Les profils ne sont plus stockes comme un fichier du nom du profil dans le
    meme repertoire que les autres mais chaque profil a desormais son repertoire
    dedie
    Les informations et preferences ne sont plus enregistrees en texte brut
  - Les hiscores ne sont plus enregistres en texte brut
  - Les sauvegardes de parties ou de snapshots ne sont plus en texte brut
  - Le jeu demarre desormais meme s'il manque tous les fichiers tant que le EBOOT
    est present et qu'au moins les textes d'une langue figurent dans "texts"
  - Correction d'un bug dans la determination de la position dans les hiscores
    qui causait egalement une corruption progressive du fichiers de hiscores
  - Modularisation du code source
  - Centrage de la grille de jeu
  - Les textes a l'ecran sont desormais separes du code
    Les textes se chargent depuis le memory stick
    Les 32 phrases les plus recentes sont gardees en memoire pour eviter de les
    recharger
    Tous les textes sont dans le repertoire texts/langue/ sous forme de fichiers
    .txt, n'importe qui peut rajouter une langue en rajoutant le repertoire et
    les fichiers correspondant.
  - Correction de trois bugs qui se remarquaient surtout en clockant le CPU de la
    PSP a 1MHz (justement pour pouvoir reperer les "bugs ephemeres")
    - Le mouvement des pieces ne fait plus de legere saccade et est parfaitement
      fluide dans le moteur de jeu
    - Le fondu de l'ecran de titre ne s'arrete plus avant d'etre completement noir
    - Le chronometre du jeu commence lorsque la grille de jeu est completement
      chargee
  - CPU a 33MHz par defaut pour ceux qui aiment jouer longtemps sans brancher
    l'alimentation (Sera adapte aux besoins a mesure du developpement) 
    (Les fonctions gourmandes clockent temporairement le CPU a 333MHz)
  - Optimisation d'une partie du code (gain de perfs atteignant les 50% parfois)
  - Le jeu prend desormais fin egalement s'il n'est plus possible de placer les
    pieces restantes
  - Reduction de la taille minimale de grille a 5x5
  - Clock temporaire a 333MHz durant tous les chargements
  - Le jeu ne bloque plus lorsqu'on modifie un profil apres avoir fait une partie

*********************************************************************************
*                                                                               *
*  Les versions precedant celle ci-dessus ne sont pas des versions publiques et *
*  n'ont ete distribuees qu'a certains amis personnels.                         *
*                                                                               *
*********************************************************************************

V 0.0.2:
  - Ajout de la gestion des profils
  - Ajout d'un chronometre
  - La duree de la partie est desormais enregistree dans les hiscores
  - Le nombre de parties et le temps moyen est stocke dans le profil
  - Ajout de la gestion des skins
  - Ajout de la notion de niveaux de difficulte
    Facile    : Afficher toutes les informations
    Normal    : Cacher le score potentiel
    Difficile : Cacher le score potentiel, le meilleur score vu, et le score actuel
  - Amelioration tres legere du contour des formes
  - Ajout d'un systeme de saisie de texte via une grille de caracteres
  - Correction d'une serie de bugs a l'enregistrement des hi-scores
  - Reduction de la quantite de RAM utilisee pour l'affichage
  - CPU a 333MHz durant l'affichage des hiscores
  - Creation du profil du joueur par defaut s'il n'existe pas pour eviter un crash
  - Restructuration partielle du repertoire de travail pour faciliter par la suite
    la distribution

V 0.0.1:
  - Nettoyage du code
  - Optimisations mineures diverses
  - Correction d'un bug mineur qui permettait de selectionner des pieces
    inexistantes.
  - Amelioration du support multi-lingue. Les textes du jeu sont desormais
    egalement affectes par la langue systeme
  - Changement de frequence a 333MHz temporaire lors du fondu de l'ecran de
    titre pour compenser le ralentissement engendre par la double-transparence.
  - Lorsqu'une piece franchit un bord, elle passe au cote oppose de la carte.
  - Le contour des formes est plus epais pour que le dessin des formes saute
    plus aux yeux.
  - Ajout de l'affichage dans la barre du bas du score de placement optimal
    la piece en cours.
  - Ajout d'une icone au .pbp.
  - Correction d'un bug lors du dessin du contour de la forme

V 0.0.0:
  Premiere version distribuee. Basique, menus encore incomplets et moches.
  - Jouable
  - Garde les scores des parties precedentes
  - Ecran de titre
